// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// User represents TL type `user#a9d4e647`.
type User struct {
	// User identifier
	ID int64
	// First name of the user
	FirstName string
	// Last name of the user
	LastName string
	// Username of the user
	Username string
	// Phone number of the user
	PhoneNumber string
	// Current online status of the user
	Status UserStatusClass
	// Profile photo of the user; may be null
	ProfilePhoto ProfilePhoto
	// The user is a contact of the current user
	IsContact bool
	// The user is a contact of the current user and the current user is a contact of the
	// user
	IsMutualContact bool
	// True, if the user is verified
	IsVerified bool
	// True, if the user is a Telegram Premium user
	IsPremium bool
	// True, if the user is Telegram support account
	IsSupport bool
	// If non-empty, it contains a human-readable description of the reason why access to
	// this user must be restricted
	RestrictionReason string
	// True, if many users reported this user as a scam
	IsScam bool
	// True, if many users reported this user as a fake account
	IsFake bool
	// If false, the user is inaccessible, and the only information known about the user is
	// inside this class. Identifier of the user can't be passed to any method except GetUser
	HaveAccess bool
	// Type of the user
	Type UserTypeClass
	// IETF language tag of the user's language; only available to bots
	LanguageCode string
	// True, if the user added the current bot to attachment menu; only available to bots
	AddedToAttachmentMenu bool
}

// UserTypeID is TL type id of User.
const UserTypeID = 0xa9d4e647

// Ensuring interfaces in compile-time for User.
var (
	_ bin.Encoder     = &User{}
	_ bin.Decoder     = &User{}
	_ bin.BareEncoder = &User{}
	_ bin.BareDecoder = &User{}
)

func (u *User) Zero() bool {
	if u == nil {
		return true
	}
	if !(u.ID == 0) {
		return false
	}
	if !(u.FirstName == "") {
		return false
	}
	if !(u.LastName == "") {
		return false
	}
	if !(u.Username == "") {
		return false
	}
	if !(u.PhoneNumber == "") {
		return false
	}
	if !(u.Status == nil) {
		return false
	}
	if !(u.ProfilePhoto.Zero()) {
		return false
	}
	if !(u.IsContact == false) {
		return false
	}
	if !(u.IsMutualContact == false) {
		return false
	}
	if !(u.IsVerified == false) {
		return false
	}
	if !(u.IsPremium == false) {
		return false
	}
	if !(u.IsSupport == false) {
		return false
	}
	if !(u.RestrictionReason == "") {
		return false
	}
	if !(u.IsScam == false) {
		return false
	}
	if !(u.IsFake == false) {
		return false
	}
	if !(u.HaveAccess == false) {
		return false
	}
	if !(u.Type == nil) {
		return false
	}
	if !(u.LanguageCode == "") {
		return false
	}
	if !(u.AddedToAttachmentMenu == false) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (u *User) String() string {
	if u == nil {
		return "User(nil)"
	}
	type Alias User
	return fmt.Sprintf("User%+v", Alias(*u))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*User) TypeID() uint32 {
	return UserTypeID
}

// TypeName returns name of type in TL schema.
func (*User) TypeName() string {
	return "user"
}

// TypeInfo returns info about TL type.
func (u *User) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "user",
		ID:   UserTypeID,
	}
	if u == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ID",
			SchemaName: "id",
		},
		{
			Name:       "FirstName",
			SchemaName: "first_name",
		},
		{
			Name:       "LastName",
			SchemaName: "last_name",
		},
		{
			Name:       "Username",
			SchemaName: "username",
		},
		{
			Name:       "PhoneNumber",
			SchemaName: "phone_number",
		},
		{
			Name:       "Status",
			SchemaName: "status",
		},
		{
			Name:       "ProfilePhoto",
			SchemaName: "profile_photo",
		},
		{
			Name:       "IsContact",
			SchemaName: "is_contact",
		},
		{
			Name:       "IsMutualContact",
			SchemaName: "is_mutual_contact",
		},
		{
			Name:       "IsVerified",
			SchemaName: "is_verified",
		},
		{
			Name:       "IsPremium",
			SchemaName: "is_premium",
		},
		{
			Name:       "IsSupport",
			SchemaName: "is_support",
		},
		{
			Name:       "RestrictionReason",
			SchemaName: "restriction_reason",
		},
		{
			Name:       "IsScam",
			SchemaName: "is_scam",
		},
		{
			Name:       "IsFake",
			SchemaName: "is_fake",
		},
		{
			Name:       "HaveAccess",
			SchemaName: "have_access",
		},
		{
			Name:       "Type",
			SchemaName: "type",
		},
		{
			Name:       "LanguageCode",
			SchemaName: "language_code",
		},
		{
			Name:       "AddedToAttachmentMenu",
			SchemaName: "added_to_attachment_menu",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (u *User) Encode(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't encode user#a9d4e647 as nil")
	}
	b.PutID(UserTypeID)
	return u.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (u *User) EncodeBare(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't encode user#a9d4e647 as nil")
	}
	b.PutInt53(u.ID)
	b.PutString(u.FirstName)
	b.PutString(u.LastName)
	b.PutString(u.Username)
	b.PutString(u.PhoneNumber)
	if u.Status == nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field status is nil")
	}
	if err := u.Status.Encode(b); err != nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field status: %w", err)
	}
	if err := u.ProfilePhoto.Encode(b); err != nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field profile_photo: %w", err)
	}
	b.PutBool(u.IsContact)
	b.PutBool(u.IsMutualContact)
	b.PutBool(u.IsVerified)
	b.PutBool(u.IsPremium)
	b.PutBool(u.IsSupport)
	b.PutString(u.RestrictionReason)
	b.PutBool(u.IsScam)
	b.PutBool(u.IsFake)
	b.PutBool(u.HaveAccess)
	if u.Type == nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field type is nil")
	}
	if err := u.Type.Encode(b); err != nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field type: %w", err)
	}
	b.PutString(u.LanguageCode)
	b.PutBool(u.AddedToAttachmentMenu)
	return nil
}

// Decode implements bin.Decoder.
func (u *User) Decode(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't decode user#a9d4e647 to nil")
	}
	if err := b.ConsumeID(UserTypeID); err != nil {
		return fmt.Errorf("unable to decode user#a9d4e647: %w", err)
	}
	return u.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (u *User) DecodeBare(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't decode user#a9d4e647 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field id: %w", err)
		}
		u.ID = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field first_name: %w", err)
		}
		u.FirstName = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field last_name: %w", err)
		}
		u.LastName = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field username: %w", err)
		}
		u.Username = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field phone_number: %w", err)
		}
		u.PhoneNumber = value
	}
	{
		value, err := DecodeUserStatus(b)
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field status: %w", err)
		}
		u.Status = value
	}
	{
		if err := u.ProfilePhoto.Decode(b); err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field profile_photo: %w", err)
		}
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field is_contact: %w", err)
		}
		u.IsContact = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field is_mutual_contact: %w", err)
		}
		u.IsMutualContact = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field is_verified: %w", err)
		}
		u.IsVerified = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field is_premium: %w", err)
		}
		u.IsPremium = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field is_support: %w", err)
		}
		u.IsSupport = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field restriction_reason: %w", err)
		}
		u.RestrictionReason = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field is_scam: %w", err)
		}
		u.IsScam = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field is_fake: %w", err)
		}
		u.IsFake = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field have_access: %w", err)
		}
		u.HaveAccess = value
	}
	{
		value, err := DecodeUserType(b)
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field type: %w", err)
		}
		u.Type = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field language_code: %w", err)
		}
		u.LanguageCode = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode user#a9d4e647: field added_to_attachment_menu: %w", err)
		}
		u.AddedToAttachmentMenu = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (u *User) EncodeTDLibJSON(b tdjson.Encoder) error {
	if u == nil {
		return fmt.Errorf("can't encode user#a9d4e647 as nil")
	}
	b.ObjStart()
	b.PutID("user")
	b.Comma()
	b.FieldStart("id")
	b.PutInt53(u.ID)
	b.Comma()
	b.FieldStart("first_name")
	b.PutString(u.FirstName)
	b.Comma()
	b.FieldStart("last_name")
	b.PutString(u.LastName)
	b.Comma()
	b.FieldStart("username")
	b.PutString(u.Username)
	b.Comma()
	b.FieldStart("phone_number")
	b.PutString(u.PhoneNumber)
	b.Comma()
	b.FieldStart("status")
	if u.Status == nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field status is nil")
	}
	if err := u.Status.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field status: %w", err)
	}
	b.Comma()
	b.FieldStart("profile_photo")
	if err := u.ProfilePhoto.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field profile_photo: %w", err)
	}
	b.Comma()
	b.FieldStart("is_contact")
	b.PutBool(u.IsContact)
	b.Comma()
	b.FieldStart("is_mutual_contact")
	b.PutBool(u.IsMutualContact)
	b.Comma()
	b.FieldStart("is_verified")
	b.PutBool(u.IsVerified)
	b.Comma()
	b.FieldStart("is_premium")
	b.PutBool(u.IsPremium)
	b.Comma()
	b.FieldStart("is_support")
	b.PutBool(u.IsSupport)
	b.Comma()
	b.FieldStart("restriction_reason")
	b.PutString(u.RestrictionReason)
	b.Comma()
	b.FieldStart("is_scam")
	b.PutBool(u.IsScam)
	b.Comma()
	b.FieldStart("is_fake")
	b.PutBool(u.IsFake)
	b.Comma()
	b.FieldStart("have_access")
	b.PutBool(u.HaveAccess)
	b.Comma()
	b.FieldStart("type")
	if u.Type == nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field type is nil")
	}
	if err := u.Type.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode user#a9d4e647: field type: %w", err)
	}
	b.Comma()
	b.FieldStart("language_code")
	b.PutString(u.LanguageCode)
	b.Comma()
	b.FieldStart("added_to_attachment_menu")
	b.PutBool(u.AddedToAttachmentMenu)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (u *User) DecodeTDLibJSON(b tdjson.Decoder) error {
	if u == nil {
		return fmt.Errorf("can't decode user#a9d4e647 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("user"); err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: %w", err)
			}
		case "id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field id: %w", err)
			}
			u.ID = value
		case "first_name":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field first_name: %w", err)
			}
			u.FirstName = value
		case "last_name":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field last_name: %w", err)
			}
			u.LastName = value
		case "username":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field username: %w", err)
			}
			u.Username = value
		case "phone_number":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field phone_number: %w", err)
			}
			u.PhoneNumber = value
		case "status":
			value, err := DecodeTDLibJSONUserStatus(b)
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field status: %w", err)
			}
			u.Status = value
		case "profile_photo":
			if err := u.ProfilePhoto.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field profile_photo: %w", err)
			}
		case "is_contact":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field is_contact: %w", err)
			}
			u.IsContact = value
		case "is_mutual_contact":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field is_mutual_contact: %w", err)
			}
			u.IsMutualContact = value
		case "is_verified":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field is_verified: %w", err)
			}
			u.IsVerified = value
		case "is_premium":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field is_premium: %w", err)
			}
			u.IsPremium = value
		case "is_support":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field is_support: %w", err)
			}
			u.IsSupport = value
		case "restriction_reason":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field restriction_reason: %w", err)
			}
			u.RestrictionReason = value
		case "is_scam":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field is_scam: %w", err)
			}
			u.IsScam = value
		case "is_fake":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field is_fake: %w", err)
			}
			u.IsFake = value
		case "have_access":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field have_access: %w", err)
			}
			u.HaveAccess = value
		case "type":
			value, err := DecodeTDLibJSONUserType(b)
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field type: %w", err)
			}
			u.Type = value
		case "language_code":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field language_code: %w", err)
			}
			u.LanguageCode = value
		case "added_to_attachment_menu":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode user#a9d4e647: field added_to_attachment_menu: %w", err)
			}
			u.AddedToAttachmentMenu = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetID returns value of ID field.
func (u *User) GetID() (value int64) {
	if u == nil {
		return
	}
	return u.ID
}

// GetFirstName returns value of FirstName field.
func (u *User) GetFirstName() (value string) {
	if u == nil {
		return
	}
	return u.FirstName
}

// GetLastName returns value of LastName field.
func (u *User) GetLastName() (value string) {
	if u == nil {
		return
	}
	return u.LastName
}

// GetUsername returns value of Username field.
func (u *User) GetUsername() (value string) {
	if u == nil {
		return
	}
	return u.Username
}

// GetPhoneNumber returns value of PhoneNumber field.
func (u *User) GetPhoneNumber() (value string) {
	if u == nil {
		return
	}
	return u.PhoneNumber
}

// GetStatus returns value of Status field.
func (u *User) GetStatus() (value UserStatusClass) {
	if u == nil {
		return
	}
	return u.Status
}

// GetProfilePhoto returns value of ProfilePhoto field.
func (u *User) GetProfilePhoto() (value ProfilePhoto) {
	if u == nil {
		return
	}
	return u.ProfilePhoto
}

// GetIsContact returns value of IsContact field.
func (u *User) GetIsContact() (value bool) {
	if u == nil {
		return
	}
	return u.IsContact
}

// GetIsMutualContact returns value of IsMutualContact field.
func (u *User) GetIsMutualContact() (value bool) {
	if u == nil {
		return
	}
	return u.IsMutualContact
}

// GetIsVerified returns value of IsVerified field.
func (u *User) GetIsVerified() (value bool) {
	if u == nil {
		return
	}
	return u.IsVerified
}

// GetIsPremium returns value of IsPremium field.
func (u *User) GetIsPremium() (value bool) {
	if u == nil {
		return
	}
	return u.IsPremium
}

// GetIsSupport returns value of IsSupport field.
func (u *User) GetIsSupport() (value bool) {
	if u == nil {
		return
	}
	return u.IsSupport
}

// GetRestrictionReason returns value of RestrictionReason field.
func (u *User) GetRestrictionReason() (value string) {
	if u == nil {
		return
	}
	return u.RestrictionReason
}

// GetIsScam returns value of IsScam field.
func (u *User) GetIsScam() (value bool) {
	if u == nil {
		return
	}
	return u.IsScam
}

// GetIsFake returns value of IsFake field.
func (u *User) GetIsFake() (value bool) {
	if u == nil {
		return
	}
	return u.IsFake
}

// GetHaveAccess returns value of HaveAccess field.
func (u *User) GetHaveAccess() (value bool) {
	if u == nil {
		return
	}
	return u.HaveAccess
}

// GetType returns value of Type field.
func (u *User) GetType() (value UserTypeClass) {
	if u == nil {
		return
	}
	return u.Type
}

// GetLanguageCode returns value of LanguageCode field.
func (u *User) GetLanguageCode() (value string) {
	if u == nil {
		return
	}
	return u.LanguageCode
}

// GetAddedToAttachmentMenu returns value of AddedToAttachmentMenu field.
func (u *User) GetAddedToAttachmentMenu() (value bool) {
	if u == nil {
		return
	}
	return u.AddedToAttachmentMenu
}
